/* 
 * AppController.m created by phr on 2000-08-27 11:38:58 +0000
 *
 * GNUstep Application Controller
 *
 * Created with ProjectCenter - http://www.gnustep.org
 *
 * $Id: AppController.m,v 1.1 2003/05/06 08:06:58 stoyan Exp $
 */

#include "AppController.h"

#include "GSGPhoto2.h"
#include "AlbumPanel.h"

#include "BCell.h"

@interface AppController(private)

- (void)transferFilesThread: (id)sender;
- (void)theAlbumPathAction: (id)sender;
- (void)SubalbumAction: (id)sender;

/* mthodes delegate de theBrowser */
- (void)browser: (NSBrowser*)sender createRowsForColumn: (int)column inMatrix: (NSMatrix*)matrix;
- (void)browserAction: (NSBrowser *)sender;

@end

@implementation AppController

static NSDictionary *infoDict = nil;

+ (void)initialize
{
  NSMutableDictionary *defaults = [NSMutableDictionary dictionary];

  /*
   * Register your app's defaults here by adding objects to the
   * dictionary, eg
   *
   * [defaults setObject:anObject forKey:keyForThatObject];
   *
   */

  NSString *defaultAlbumPath;
  defaultAlbumPath = [NSHomeDirectory() stringByAppendingPathComponent: @"CameraTransfer/Album"];
  [defaults setObject: defaultAlbumPath forKey: @"AlbumPath"];

  NSString *defaultSubalbum;
  defaultSubalbum = @"";
  [defaults setObject: defaultSubalbum forKey: @"Subalbum"];
  
  [[NSUserDefaults standardUserDefaults] registerDefaults: defaults];
  [[NSUserDefaults standardUserDefaults] synchronize];
}


- (id)init
{
  self = [super init];

  NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

  theAlbumPath = [defaults objectForKey: @"AlbumPath"];
  RETAIN(theAlbumPath);

  return self;
}


- (void)dealloc
{
  RELEASE(theMainWindow);
  [super dealloc];
}


- (void)awakeFromNib
{
}


- (void)applicationWillFinishLaunching:(NSNotification *)notif
{
  NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

  theMainWindow = [[NSWindow alloc] initWithContentRect: NSMakeRect(300, 300, 500, 374)
				    styleMask: (NSTitledWindowMask |
						NSMiniaturizableWindowMask |
						NSResizableWindowMask)
				    backing: NSBackingStoreBuffered
				    defer: YES];
  [theMainWindow setTitle: @"CamPics"];

  [self detectCameras: self];

  NSImage *img = [[NSImage alloc] initWithContentsOfFile: @"CameraTransfer_header.tiff"];
  theLogo = [[NSImageView alloc] initWithFrame: NSMakeRect(5, 300, 400, 64)];
  [theLogo setAutoresizingMask: (NSViewMaxXMargin | NSViewMinYMargin) ];
  [theLogo setImage: img];
  
  [[theMainWindow contentView] addSubview: theLogo];
  RELEASE(img);

  theBrowser = [[NSBrowser alloc] init];
  [theBrowser setFrame: NSMakeRect(5, 34, 490, 261)];
  [theBrowser setCellClass: [BCell class]];
  [theBrowser setAutoresizingMask: NSViewWidthSizable | NSViewHeightSizable];
  [theBrowser setTitled: NO];
  [theBrowser setDelegate: self];
  [[theMainWindow contentView] addSubview: theBrowser];

  theTransferButton = [[NSButton alloc] initWithFrame: NSMakeRect(5, 5, 86, 24)];
  [theTransferButton setStringValue: @"Transfer to"];
  [theTransferButton setTarget: self];
  [theTransferButton setAction: @selector(transferFiles:)];
  [[theMainWindow contentView] addSubview: theTransferButton];

  thePathView = [[NSTextField alloc] initWithFrame: NSMakeRect(96, 5, 370, 24)];
  [thePathView setEditable: NO];
  [thePathView setAutoresizingMask: NSViewWidthSizable];
  [thePathView setStringValue: [defaults objectForKey: @"Subalbum"]];
  [[theMainWindow contentView] addSubview: thePathView];

  theSubalbumButton = [[NSButton alloc] initWithFrame: NSMakeRect(471, 5, 24, 24)];
  [theSubalbumButton setStringValue: @"..."];
  [theSubalbumButton setAutoresizingMask: NSViewMinXMargin];
  [theSubalbumButton setTarget: self];
  [theSubalbumButton setAction: @selector(SubalbumAction:)];
  [[theMainWindow contentView] addSubview: theSubalbumButton];
}


- (void)applicationDidFinishLaunching:(NSNotification *)notif
{
  [theMainWindow makeKeyAndOrderFront: self];
}


- (BOOL)applicationShouldTerminate:(id)sender
{
  return YES;
}


- (void)applicationWillTerminate:(NSNotification *)notification
{
  RELEASE(theBrowser);
  RELEASE(theCameraList);
}


- (BOOL)application:(NSApplication *)application openFile:(NSString *)fileName
{
}


- (void)showPrefPanel:(id)sender
{
  if (thePrefPanel == nil)
    {
      NSAutoreleasePool *pool;
      NSTextField *label;

      pool = [NSAutoreleasePool new];

      thePrefPanel = [[NSPanel alloc] initWithContentRect: NSMakeRect(200, 200, 272, 100)
				      styleMask: (NSTitledWindowMask |
						  NSClosableWindowMask)
				      backing: NSBackingStoreBuffered
				      defer: YES];
      [thePrefPanel setTitle: @"Preferences"];

      label = AUTORELEASE([[NSTextField alloc] initWithFrame: NSMakeRect(5, 71, 70, 24)]);
      [label setStringValue: @"Album path"];
      [label setEditable: NO];
      [label setSelectable: NO];
      [label setBezeled: NO];
      [label setBordered: NO];
      [label setDrawsBackground: NO];
      [[thePrefPanel contentView] addSubview: label];

      theAlbumPathView = [[NSTextField alloc] initWithFrame: NSMakeRect(80, 71, 161, 24)];
      [theAlbumPathView setEditable: NO];
      [theAlbumPathView setStringValue: theAlbumPath];
      [theAlbumPathView setDelegate: self];
      [[thePrefPanel contentView] addSubview: theAlbumPathView];
      
      theAlbumPathButton = [[NSButton alloc] initWithFrame: NSMakeRect(243, 71, 24, 24)];
      [theAlbumPathButton setStringValue: @"..."];
      [theAlbumPathButton setAction: @selector(theAlbumPathAction:)];
      [theAlbumPathButton setTarget: self];
      [[thePrefPanel contentView] addSubview: theAlbumPathButton];

      RELEASE(pool);
    }
  [thePrefPanel  makeKeyAndOrderFront: self];
}

- (void) theAlbumPathAction: (id)sender
{
  NSOpenPanel *openpan;
  openpan = [NSOpenPanel openPanel];
  [openpan setCanChooseFiles: NO];
  [openpan setCanChooseDirectories: YES];
  [openpan setAllowsMultipleSelection: NO];
  if ([openpan runModalForDirectory: theAlbumPath file: nil types: nil] == NSOKButton)
    {
      RELEASE(theAlbumPath);
      theAlbumPath = [[NSString alloc] initWithString: [[openpan filenames] objectAtIndex: 0]];
      [theAlbumPathView setStringValue: theAlbumPath];

      NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
      [defaults setObject: theAlbumPath forKey: @"AlbumPath"];

      if ([NSString stringWithFormat: @"%@/%@", theAlbumPath, [thePathView stringValue]])
	{
	  [thePathView setStringValue: @""];
	  NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	  [defaults setObject: [thePathView stringValue] forKey: @"Subalbum"];
	}
    }
}


- (void)showInfoPanel:(id)sender
{
  [[NSApplication sharedApplication] orderFrontStandardInfoPanel:sender];
}


- (void)browser: (NSBrowser*)sender createRowsForColumn: (int)column inMatrix: (NSMatrix*)matrix
{
  int i, countfolders, count;
  NSBrowserCell *cell;

  if (column == 0)
    {
      count = [theCameraList numberOfCameras];
      for (i=0; i<count; i++)
	{
	  [matrix addRow];
	  cell = [matrix cellAtRow: i column: 0];
	  [cell setStringValue: [theCameraList nameOfCameraAtIndex: i]];
	  [cell setRepresentedObject: [theCameraList cameraAtIndex: i]];
	  [cell setLeaf: NO];
	}
    }
  else
    {
      NSArray *ar;
      GSCamera *cam;
      NSString *path;
      NSString *tmp;

      cam = (GSCamera *)[[theBrowser selectedCellInColumn: 0] representedObject];

      if (column == 1)
	{
	  path = @"/";
	  tmp = @"";
	}
      else
	{
	  path = [[theBrowser selectedCellInColumn: column-1] representedObject];
	  tmp = path;
	}
      
      ar = [cam foldersInPath: path];
      countfolders = [ar count];
      for (i=0; i<countfolders; i++)
	{
	  [matrix addRow];
	  cell = [matrix cellAtRow: i column: 0];
	  [cell setStringValue: [ar objectAtIndex: i]];
	  [cell setRepresentedObject: [NSString stringWithFormat: @"%@/%@", tmp, [ar objectAtIndex: i]]];
	  [cell setLeaf: NO];
	}
      RELEASE(ar);

      ar = [cam filesInPath: path];
      count = [ar count];
      for (i=0; i<count; i++)
	{
	  [matrix addRow];
	  cell = [matrix cellAtRow: i+countfolders column: 0];
	  [cell setStringValue: [ar objectAtIndex: i]];
	  [cell setRepresentedObject: [NSString stringWithFormat: @"%@/%@", tmp, [ar objectAtIndex: i]]];
	  [cell setLeaf: YES];
	}
      RELEASE(ar);
    }
}


- (void)browserAction: (NSBrowser *)sender
{
  NSLog(@"%@", [[sender selectedCell] representedObject]);
}


- (void)detectCameras: (id)sender
{
  if (theCameraList != nil)
    {
      [theCameraList reinit];
    }
  else
    {
      theCameraList = [[GSGPhoto2 alloc] init];
    }
  if (theBrowser != nil) [theBrowser reloadColumn: 0];
}

- (void)transferFiles: (id)sender
{
  NSMutableArray *ar;

  ar = [[NSMutableArray alloc] init];

  if (theProgressPanel == nil)
    {
      theProgressPanel = [[NSWindow alloc] initWithContentRect: NSMakeRect(400, 400, 200, 34)
					    styleMask: (NSTitledWindowMask)
					    backing: NSBackingStoreBuffered
					    defer: YES];
      theProgressLabel = [[NSTextField alloc] initWithFrame: NSMakeRect(5, 5, 190, 24)];
      [theProgressLabel setEditable: NO];
      [theProgressLabel setSelectable: NO];
      [theProgressLabel setBezeled: NO];
      [theProgressLabel setBordered: NO];
      [theProgressLabel setDrawsBackground: NO];
      [[theProgressPanel contentView] addSubview: theProgressLabel];
      [theProgressPanel setTitle: @"Transfer..."];
    }
  [theProgressPanel  makeKeyAndOrderFront: self];  

  [ar addObject: theProgressPanel];
  [ar addObject: theProgressLabel];
  [ar addObject: self];

  [NSThread detachNewThreadSelector: @selector(transferFilesThread:) toTarget: self withObject: ar];
}

- (void)transferFilesThread: (id)sender
{
  NSArray *ar;
  NSBrowserCell *cell;
  NSAutoreleasePool *pool;
  GSCamera *cam;
  int i;

  pool = [NSAutoreleasePool new];

  cam = (GSCamera *)[[theBrowser selectedCellInColumn: 0] representedObject];

  ar = [theBrowser selectedCells];
  for (i=0; i<[ar count]; i++)
    {
      cell = [ar objectAtIndex: i];
      if ([cell isLeaf])
	{
	  [[sender objectAtIndex: 1] setStringValue: [cell stringValue]];
	  [cam getFile: [cell stringValue] from: [[cell representedObject] stringByDeletingLastPathComponent] to: [NSString stringWithFormat: @"%@/%@", theAlbumPath, [thePathView stringValue]]];
	}
    }

  [[sender objectAtIndex: 0] orderOut: self];

  RELEASE(pool);
}


- (void)SubalbumAction: (id)sender
{
  NSAutoreleasePool *pool = [NSAutoreleasePool new];
  AlbumPanel *panel;
  panel = [[AlbumPanel alloc] init];
  if ([panel runModalForDirectory: theAlbumPath Subalbum: @""] == OK_BUTTON)
    {
      [thePathView setStringValue: [panel selectedAlbum]];
      NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
      [defaults setObject: [thePathView stringValue] forKey: @"Subalbum"];
    }
  RELEASE(panel);
  RELEASE(pool);
}

@end
